version: "3"

services:
  server:
    image: {{ gitea_image }}:{{ gitea_ver }}
    container_name: {{ gitea_container_name }}
    restart: always
    networks:
      {{ gitea_network }}:
      {{ traefik_network }}:
    ports:
      # - "{{ gitea_web_port }}:3000"
      - "127.0.0.1:2222:22"
    volumes:
      - {{ gitea_home }}/data:/data
      - /etc/timezone:/etc/timezone:ro
      - /etc/localtime:/etc/localtime:ro
      - /home/git/.ssh/:/data/git/.ssh
    environment:
      - USER_UID={{ gitea_uid }}
      - USER_GID={{ gitea_uid }}
      - GITEA__server__PROTOCOL=http
      - GITEA__server__DOMAIN="{{ gitea_container_name }}.{{ traefik_zone }}"
      - GITEA__server__ROOT_URL="https://%(DOMAIN)s/"
      - GITEA__database__DB_TYPE=mysql
      - GITEA__database__HOST=db:3306
      - GITEA__database__NAME=${MYSQL_DATABASE}
      - GITEA__database__USER=${MYSQL_USER}
      - GITEA__database__PASSWD=${MYSQL_PASSWORD}
      - GITEA__mailer__ENABLED=true
      - GITEA__mailer__HOST=smtp.gmail.com:465
      - GITEA__mailer__FROM=gitea.{{ gitea_email }}
      - GITEA__mailer__USER={{ gitea_email }}
      - GITEA__mailer__PASSWD={{ gitea_email_gmail_pass }}
      - GITEA__mailer__MAILER_TYPE=smtp
      - GITEA__mailer__IS_TLS_ENABLED=true
      - GITEA__mailer__HELO_HOSTNAME="{{ gitea_container_name }}.{{ traefik_zone }}"
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.{{ gitea_container_name }}.entrypoints=http"
      - "traefik.http.routers.{{ gitea_container_name }}.rule=Host(`{{ gitea_container_name }}.{{ traefik_zone }}`)"
      - "traefik.http.middlewares.{{ gitea_container_name }}-https-redirect.redirectscheme.scheme=https"
      - "traefik.http.routers.{{ gitea_container_name }}.middlewares={{ gitea_container_name }}-https-redirect"
      - "traefik.http.routers.{{ gitea_container_name }}-secure.entrypoints=https"
      - "traefik.http.routers.{{ gitea_container_name }}-secure.rule=Host(`{{ gitea_container_name }}.{{ traefik_zone }}`)"
      - "traefik.http.routers.{{ gitea_container_name }}-secure.tls=true"
      - "traefik.http.routers.{{ gitea_container_name }}-secure.service={{ gitea_container_name }}"
      - "traefik.http.services.{{ gitea_container_name }}.loadbalancer.server.port=3000"
      - "traefik.docker.network={{ traefik_network }}"
    depends_on:
      - db

  db:
    image: {{ gitea_db_image }}:{{ gitea_db_ver }}
    restart: always
    user: {{ ansible_user_uid }}:{{ ansible_user_gid }}
    environment:
      - MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}
      - MYSQL_USER=${MYSQL_USER}
      - MYSQL_PASSWORD=${MYSQL_PASSWORD}
      - MYSQL_DATABASE=${MYSQL_DATABASE}
    networks:
      {{ gitea_network }}:
    volumes:
      - {{ gitea_home }}/mysql:/var/lib/mysql

networks:
  {{ gitea_network }}:
    external: false
  {{ traefik_network }}:
    external: true
